// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.el.MethodExpression;
import javax.faces.component.ActionSource2;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUITabGroup;
import org.apache.myfaces.tobago.layout.Display;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a tab group which contains tab panels.
  * UIComponent class, generated from template {@code component2.0.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.TabGroupTagDeclaration}.
 */
public class UITabGroup
    extends AbstractUITabGroup implements SupportsMarkup, ActionSource2 {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.TabGroup";

  public static final String COMPONENT_FAMILY = "javax.faces.Panel";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    columnSpan,
    preferredWidth,
    renderedIndex,
    switchType,
    tabChangeListener,
    horizontalIndex,
    paddingRight,
    borderTop,
    preferredHeight,
    marginRight,
    borderLeft,
    actionListener,
    paddingBottom,
    top,
    currentWidth,
    maximumWidth,
    action,
    currentHeight,
    showNavigationBar,
    paddingTop,
    borderBottom,
    height,
    rowSpan,
    markup,
    display,
    minimumHeight,
    marginLeft,
    renderedPartially,
    selectedIndex,
    overflowX,
    overflowY,
    immediate,
    left,
    borderRight,
    width,
    maximumHeight,
    marginBottom,
    verticalIndex,
    minimumWidth,
    paddingLeft,
    marginTop,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public java.lang.Integer getColumnSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.columnSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setColumnSpan(java.lang.Integer columnSpan) {
    getStateHelper().put(PropertyKeys.columnSpan, columnSpan);
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredWidth() {
    Object object = getStateHelper().eval(PropertyKeys.preferredWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredWidth(org.apache.myfaces.tobago.layout.Measure preferredWidth) {
    getStateHelper().put(PropertyKeys.preferredWidth, preferredWidth);
  }

  /**
  For internal use. TODO: Check if this long needed
  <br />Default: <code>0</code>
  */
  public java.lang.Integer getRenderedIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.renderedIndex);
    if (value != null) {
      return value.intValue();
    }
    return 0;
  }

  public void setRenderedIndex(java.lang.Integer renderedIndex) {
    getStateHelper().put(PropertyKeys.renderedIndex, renderedIndex);
  }

  /**
  Indicating how tab switching should be done.
   <p/>
   Possible values are:
   <dl>
     <dt>client</dt>
     <dd>Tab switching is done on client, no server Request.</dd>
     <dt>reloadPage</dt>
     <dd>Tab switching is done by server request. Full page is reloaded.</dd>
     <dt>reloadTab</dt>
     <dd>Tab switching is done by server request. Only the Tab is reloaded.</dd>
   </dl>
  <br />Default: <code>client</code><br />Allowed Values: <code>client,reloadPage,reloadTab</code>
  */
  public java.lang.String getSwitchType() {
    java.lang.String switchType = (java.lang.String) getStateHelper().eval(PropertyKeys.switchType);
    if (switchType != null) {
      return switchType;
    }
    return "client";
  }

  public void setSwitchType(java.lang.String switchType) {
    getStateHelper().put(PropertyKeys.switchType, switchType);
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public javax.faces.el.MethodBinding getTabChangeListener() {
    javax.el.MethodExpression expression = getTabChangeListenerExpression();
    if (expression instanceof MethodBindingToMethodExpression) {
      return ((MethodBindingToMethodExpression)expression).getMethodBinding();
    }
    if (expression != null) {
       return new MethodExpressionToMethodBinding(expression);
    }
    return null;
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public void setTabChangeListener(javax.faces.el.MethodBinding tabChangeListener) {
    if (tabChangeListener != null) {
      setTabChangeListenerExpression(new MethodBindingToMethodExpression(tabChangeListener));
    } else {
      setTabChangeListenerExpression(null);
    }
  }

  public javax.el.MethodExpression getTabChangeListenerExpression() {
    return (javax.el.MethodExpression) getStateHelper().eval(PropertyKeys.tabChangeListener);
  }

  public void setTabChangeListenerExpression(javax.el.MethodExpression tabChangeListener) {
    getStateHelper().put(PropertyKeys.tabChangeListener, tabChangeListener);
  }


  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getHorizontalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.horizontalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setHorizontalIndex(java.lang.Integer horizontalIndex) {
    getStateHelper().put(PropertyKeys.horizontalIndex, horizontalIndex);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingRight() {
    Object object = getStateHelper().eval(PropertyKeys.paddingRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingRight(org.apache.myfaces.tobago.layout.Measure paddingRight) {
    getStateHelper().put(PropertyKeys.paddingRight, paddingRight);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderTop() {
    Object object = getStateHelper().eval(PropertyKeys.borderTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderTop(org.apache.myfaces.tobago.layout.Measure borderTop) {
    getStateHelper().put(PropertyKeys.borderTop, borderTop);
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredHeight() {
    Object object = getStateHelper().eval(PropertyKeys.preferredHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredHeight(org.apache.myfaces.tobago.layout.Measure preferredHeight) {
    getStateHelper().put(PropertyKeys.preferredHeight, preferredHeight);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginRight() {
    Object object = getStateHelper().eval(PropertyKeys.marginRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginRight(org.apache.myfaces.tobago.layout.Measure marginRight) {
    getStateHelper().put(PropertyKeys.marginRight, marginRight);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderLeft() {
    Object object = getStateHelper().eval(PropertyKeys.borderLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
   getRenderer(getFacesContext())).getBorderLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderLeft(org.apache.myfaces.tobago.layout.Measure borderLeft) {
    getStateHelper().put(PropertyKeys.borderLeft, borderLeft);
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public javax.faces.el.MethodBinding getActionListener() {
    javax.el.MethodExpression expression = getActionListenerExpression();
    if (expression instanceof MethodBindingToMethodExpression) {
      return ((MethodBindingToMethodExpression)expression).getMethodBinding();
    }
    if (expression != null) {
       return new MethodExpressionToMethodBinding(expression);
    }
    return null;
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public void setActionListener(javax.faces.el.MethodBinding actionListener) {
    if (actionListener != null) {
      setActionListenerExpression(new MethodBindingToMethodExpression(actionListener));
    } else {
      setActionListenerExpression(null);
    }
  }

  public javax.el.MethodExpression getActionListenerExpression() {
    return (javax.el.MethodExpression) getStateHelper().eval(PropertyKeys.actionListener);
  }

  public void setActionListenerExpression(javax.el.MethodExpression actionListener) {
    getStateHelper().put(PropertyKeys.actionListener, actionListener);
  }


  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingBottom() {
    Object object = getStateHelper().eval(PropertyKeys.paddingBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingBottom(org.apache.myfaces.tobago.layout.Measure paddingBottom) {
    getStateHelper().put(PropertyKeys.paddingBottom, paddingBottom);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getTop() {
    Object object = getStateHelper().eval(PropertyKeys.top);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setTop(org.apache.myfaces.tobago.layout.Measure top) {
    getStateHelper().put(PropertyKeys.top, top);
  }

  /**
  This value will usually be set by the layout manager. It holds the current width computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentWidth() {
    Object object = getStateHelper().eval(PropertyKeys.currentWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getWidth();
  }

  public void setCurrentWidth(org.apache.myfaces.tobago.layout.Measure currentWidth) {
    getStateHelper().put(PropertyKeys.currentWidth, currentWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.maximumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumWidth(org.apache.myfaces.tobago.layout.Measure maximumWidth) {
    getStateHelper().put(PropertyKeys.maximumWidth, maximumWidth);
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public javax.faces.el.MethodBinding getAction() {
    javax.el.MethodExpression expression = getActionExpression();
    if (expression instanceof MethodBindingToMethodExpression) {
      return ((MethodBindingToMethodExpression)expression).getMethodBinding();
    }
    if (expression != null) {
       return new MethodExpressionToMethodBinding(expression);
    }
    return null;
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public void setAction(javax.faces.el.MethodBinding action) {
    if (action != null) {
      setActionExpression(new MethodBindingToMethodExpression(action));
    } else {
      setActionExpression(null);
    }
  }

  public javax.el.MethodExpression getActionExpression() {
    return (javax.el.MethodExpression) getStateHelper().eval(PropertyKeys.action);
  }

  public void setActionExpression(javax.el.MethodExpression action) {
    getStateHelper().put(PropertyKeys.action, action);
  }


  /**
  This value will usually be set by the layout manager. It holds the current height computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentHeight() {
    Object object = getStateHelper().eval(PropertyKeys.currentHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getHeight();
  }

  public void setCurrentHeight(org.apache.myfaces.tobago.layout.Measure currentHeight) {
    getStateHelper().put(PropertyKeys.currentHeight, currentHeight);
  }

  /**
  Flag indicating that the tab navigation bar is rendered.
  <br />Default: <code>true</code>
  */
  public boolean isShowNavigationBar() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showNavigationBar);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setShowNavigationBar(boolean showNavigationBar) {
    getStateHelper().put(PropertyKeys.showNavigationBar, showNavigationBar);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingTop() {
    Object object = getStateHelper().eval(PropertyKeys.paddingTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingTop(org.apache.myfaces.tobago.layout.Measure paddingTop) {
    getStateHelper().put(PropertyKeys.paddingTop, paddingTop);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderBottom() {
    Object object = getStateHelper().eval(PropertyKeys.borderBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderBottom(org.apache.myfaces.tobago.layout.Measure borderBottom) {
    getStateHelper().put(PropertyKeys.borderBottom, borderBottom);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getHeight() {
    Object object = getStateHelper().eval(PropertyKeys.height);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setHeight(org.apache.myfaces.tobago.layout.Measure height) {
    getStateHelper().put(PropertyKeys.height, height);
  }

  public java.lang.Integer getRowSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.rowSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setRowSpan(java.lang.Integer rowSpan) {
    getStateHelper().put(PropertyKeys.rowSpan, rowSpan);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Display getDisplay() {
    return (org.apache.myfaces.tobago.layout.Display) getStateHelper().eval(PropertyKeys.display);
  }

  public void setDisplay(org.apache.myfaces.tobago.layout.Display display) {
    getStateHelper().put(PropertyKeys.display, display);
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.minimumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumHeight(org.apache.myfaces.tobago.layout.Measure minimumHeight) {
    getStateHelper().put(PropertyKeys.minimumHeight, minimumHeight);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginLeft() {
    Object object = getStateHelper().eval(PropertyKeys.marginLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginLeft(org.apache.myfaces.tobago.layout.Measure marginLeft) {
    getStateHelper().put(PropertyKeys.marginLeft, marginLeft);
  }

  /**
  <p>
   Indicate the partially rendered components in a case of a submit.
   </p>
   <p>
   The search depends on the number of prefixed colons in the relativeId:
   <dl>
     <dd>number of prefixed colons == 0</dd>
     <dt>fully relative</dt>
     <dd>number of prefixed colons == 1</dd>
     <dt>absolute (still normal findComponent syntax)</dt>
     <dd>number of prefixed colons == 2</dd>
     <dt>search in the current naming container (same as 0 colons)</dt>
     <dd>number of prefixed colons == 3</dd>
     <dt>search in the parent naming container of the current naming container</dt>
     <dd>number of prefixed colons > 3</dd>
     <dt>go to the next parent naming container for each additional colon</dt>
   </dl>
   </p>
   <p>
   If a literal is specified: to use more than one identifier the identifiers must be space delimited.
   </p>
   <p>
   Using this in a UISheet or UITabGroup component this list indicates components to update when calling
   internal AJAX requests like sort or paging commands.
   Don't forget to add the sheet-id or tagGroup-id in that case, if needed.
   </p>
   <p>
   You can also use

  */
  public String[] getRenderedPartially() {
    Object strArray = getStateHelper().eval(PropertyKeys.renderedPartially);
    if (strArray != null) {
      if (strArray instanceof String[]) {
        return (String[]) strArray;
      } else if (strArray instanceof String) {
        String[] strings = StringUtils.split((String) strArray, ", ");
        List<String> result = new ArrayList<String>(strings.length);
        for (String string : strings) {
          if (string.trim().length() != 0) {
            result.add(string.trim());
          }
        }
        return result.toArray(new String[result.size()]);
      } else if (strArray == null) {
        return org.apache.myfaces.tobago.internal.util.ArrayUtils.EMPTY_STRING_ARRAY;
      } else {
        return new String[]{strArray.toString()};
      }
    }
    return org.apache.myfaces.tobago.internal.util.ArrayUtils.EMPTY_STRING_ARRAY;
  }

  public void setRenderedPartially(String[] renderedPartially) {
    getStateHelper().put(PropertyKeys.renderedPartially, renderedPartially);
  }

  /**
  <strong>ValueBindingExpression</strong> pointing to a Integer to save the
   component's selected Tab.
  <br />Default: <code>0</code>
  */
  public java.lang.Integer getSelectedIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.selectedIndex);
    if (value != null) {
      return value.intValue();
    }
    return 0;
  }

  public void setSelectedIndex(java.lang.Integer selectedIndex) {
    getStateHelper().put(PropertyKeys.selectedIndex, selectedIndex);
  }

  /**
  This attribute is for internal use only.

  */
  public boolean isOverflowX() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.overflowX);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setOverflowX(boolean overflowX) {
    getStateHelper().put(PropertyKeys.overflowX, overflowX);
  }

  /**
  This attribute is for internal use only.

  */
  public boolean isOverflowY() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.overflowY);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setOverflowY(boolean overflowY) {
    getStateHelper().put(PropertyKeys.overflowY, overflowY);
  }

  /**
  Flag indicating that, if this component is activated by the user, notifications should be delivered to interested
   listeners and actions immediately (that is, during Apply Request Values phase) rather than waiting until Invoke
   Application phase.
  <br />Default: <code>false</code>
  */
  public boolean isImmediate() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.immediate);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setImmediate(boolean immediate) {
    getStateHelper().put(PropertyKeys.immediate, immediate);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getLeft() {
    Object object = getStateHelper().eval(PropertyKeys.left);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setLeft(org.apache.myfaces.tobago.layout.Measure left) {
    getStateHelper().put(PropertyKeys.left, left);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderRight() {
    Object object = getStateHelper().eval(PropertyKeys.borderRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderRight(org.apache.myfaces.tobago.layout.Measure borderRight) {
    getStateHelper().put(PropertyKeys.borderRight, borderRight);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getWidth() {
    Object object = getStateHelper().eval(PropertyKeys.width);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setWidth(org.apache.myfaces.tobago.layout.Measure width) {
    getStateHelper().put(PropertyKeys.width, width);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.maximumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumHeight(org.apache.myfaces.tobago.layout.Measure maximumHeight) {
    getStateHelper().put(PropertyKeys.maximumHeight, maximumHeight);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginBottom() {
    Object object = getStateHelper().eval(PropertyKeys.marginBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginBottom(org.apache.myfaces.tobago.layout.Measure marginBottom) {
    getStateHelper().put(PropertyKeys.marginBottom, marginBottom);
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getVerticalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.verticalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setVerticalIndex(java.lang.Integer verticalIndex) {
    getStateHelper().put(PropertyKeys.verticalIndex, verticalIndex);
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.minimumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumWidth(org.apache.myfaces.tobago.layout.Measure minimumWidth) {
    getStateHelper().put(PropertyKeys.minimumWidth, minimumWidth);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingLeft() {
    Object object = getStateHelper().eval(PropertyKeys.paddingLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingLeft(org.apache.myfaces.tobago.layout.Measure paddingLeft) {
    getStateHelper().put(PropertyKeys.paddingLeft, paddingLeft);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginTop() {
    Object object = getStateHelper().eval(PropertyKeys.marginTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginTop(org.apache.myfaces.tobago.layout.Measure marginTop) {
    getStateHelper().put(PropertyKeys.marginTop, marginTop);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}